## dwarves 1.22

=== CMakeLists.txt ===
project(pahole C)
cmake_minimum_required(VERSION 2.8.12)
cmake_policy(SET CMP0005 NEW)

option(LIBBPF_EMBEDDED "Use the embedded version of libbpf instead of searching it via pkg-config" ON)
if (NOT LIBBPF_EMBEDDED)
	find_package(PkgConfig REQUIRED)
	if(PKGCONFIG_FOUND)
		pkg_check_modules(LIBBPF REQUIRED libbpf>=0.4.0)
	endif()
endif()

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}
		    ${CMAKE_CURRENT_SOURCE_DIR})
if(NOT LIBBPF_FOUND)
	# Allows to use 'system' style #include with both embedded and system libbpf
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/lib/include)
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/lib/bpf/include/uapi)
else()
	INCLUDE_DIRECTORIES(${LIBBPF_INCLUDE_DIRS})
	LINK_DIRECTORIES(${LIBBPF_LIBRARY_DIRS})
endif()

# Try to parse this later, Helio just showed me a KDE4 example to support
# x86-64 builds.
# the following are directories where stuff will be installed to
set(__LIB "" CACHE STRING "Define suffix of directory name (32/64)" )

macro(_set_fancy _var _value _comment)
	if (NOT DEFINED ${_var})
		set(${_var} ${_value})
	else (NOT DEFINED ${_var})
		set(${_var} "${${_var}}" CACHE PATH "${_comment}")
	endif (NOT DEFINED ${_var})
endmacro(_set_fancy)

# where to look first for cmake modules,
# before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

if (NOT CMAKE_BUILD_TYPE)
	set (CMAKE_BUILD_TYPE Debug CACHE STRING
	     "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
	     FORCE)
endif (NOT CMAKE_BUILD_TYPE)

set(CMAKE_C_FLAGS_DEBUG "-Wall -Werror -ggdb -O0")
set(CMAKE_C_FLAGS_RELEASE "-Wall -O2")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")

if (NOT DEFINED BUILD_SHARED_LIBS)
	set (BUILD_SHARED_LIBS ON)
	message(STATUS "Setting BUILD_SHARED_LIBS = ${BUILD_SHARED_LIBS}")
endif (NOT DEFINED BUILD_SHARED_LIBS)

# Just for grepping, DWARVES_VERSION isn't used anywhere anymore
# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.22")
add_definitions(-D_GNU_SOURCE -DDWARVES_MAJOR_VERSION=1)
add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=22)
find_package(DWARF REQUIRED)
find_package(ZLIB REQUIRED)
find_package(argp REQUIRED)
find_package(obstack REQUIRED)

# make sure git submodule(s) are checked out
find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
	# Update submodules as needed
	option(GIT_SUBMODULE "Check submodules during build" ON)
	if(GIT_SUBMODULE)
		message(STATUS "Submodule update")
		execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive
				WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
				RESULT_VARIABLE GIT_SUBMOD_RESULT)
		if(NOT GIT_SUBMOD_RESULT EQUAL "0")
			message(FATAL_ERROR "git submodule update --init failed with ${GIT_SUBMOD_RESULT}, please checkout submodules")
		else()
			message(STATUS "Submodule update - done")
		endif()
	endif()
endif()
if(NOT LIBBPF_FOUND AND NOT EXISTS "${PROJECT_SOURCE_DIR}/lib/bpf/src/btf.h")
	message(FATAL_ERROR "The submodules were not downloaded! GIT_SUBMODULE was turned off or failed. Please update submodules and try again.")
endif()

_set_fancy(LIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}${CMAKE_INSTALL_PREFIX}/${__LIB}" "libdir")

# libbpf uses reallocarray, which is not available in all versions of glibc
# libbpf's include/tools/libc_compat.h provides implementation, but needs
# COMPACT_NEED_REALLOCARRAY to be set
INCLUDE(CheckCSourceCompiles)
CHECK_C_SOURCE_COMPILES(
"
#define _GNU_SOURCE
#include <stdlib.h>
int main(void)
{
        return !!reallocarray(NULL, 1, 1);
}
" HAVE_REALLOCARRAY_SUPPORT)
if (NOT HAVE_REALLOCARRAY_SUPPORT)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DCOMPAT_NEED_REALLOCARRAY")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64")

if (NOT LIBBPF_FOUND)
	file(GLOB libbpf_sources "lib/bpf/src/*.c")
	add_library(bpf OBJECT ${libbpf_sources})
	set_property(TARGET bpf PROPERTY POSITION_INDEPENDENT_CODE 1)
	target_include_directories(bpf PRIVATE
				   ${CMAKE_CURRENT_SOURCE_DIR}/lib/bpf/include
				   ${CMAKE_CURRENT_SOURCE_DIR}/lib/bpf/include/uapi)
endif()

set(dwarves_LIB_SRCS dwarves.c dwarves_fprintf.c gobuffer.c
		     ctf_loader.c libctf.c btf_encoder.c btf_loader.c
		     dwarf_loader.c dutil.c elf_symtab.c rbtree.c)
if (NOT LIBBPF_FOUND)
	list(APPEND dwarves_LIB_SRCS $<TARGET_OBJECTS:bpf>)
endif()
add_library(dwarves ${dwarves_LIB_SRCS})
set_target_properties(dwarves PROPERTIES VERSION 1.0.0 SOVERSION 1)
set_target_properties(dwarves PROPERTIES INTERFACE_LINK_LIBRARIES "")
target_link_libraries(dwarves ${DWARF_LIBRARIES} ${ZLIB_LIBRARIES} ${LIBBPF_LIBRARIES} ${ARGP_LIBRARY} ${OBSTACK_LIBRARY})

set(dwarves_emit_LIB_SRCS dwarves_emit.c)
add_library(dwarves_emit ${dwarves_emit_LIB_SRCS})
set_target_properties(dwarves_emit PROPERTIES VERSION 1.0.0 SOVERSION 1)
target_link_libraries(dwarves_emit dwarves)

set(dwarves_reorganize_LIB_SRCS dwarves_reorganize.c)
add_library(dwarves_reorganize ${dwarves_reorganize_LIB_SRCS})
set_target_properties(dwarves_reorganize PROPERTIES VERSION 1.0.0 SOVERSION 1)
target_link_libraries(dwarves_reorganize dwarves)

set(codiff_SRCS codiff.c)
add_executable(codiff ${codiff_SRCS})
target_link_libraries(codiff dwarves)

set(ctracer_SRCS ctracer.c)
add_executable(ctracer ${ctracer_SRCS})
target_link_libraries(ctracer dwarves dwarves_emit dwarves_reorganize ${ELF_LIBRARY})

set(dtagnames_SRCS dtagnames.c)
add_executable(dtagnames ${dtagnames_SRCS})
target_link_libraries(dtagnames dwarves)

set(pahole_SRCS pahole.c)
add_executable(pahole ${pahole_SRCS})
target_link_libraries(pahole dwarves dwarves_reorganize)

set(pdwtags_SRCS pdwtags.c)
add_executable(pdwtags ${pdwtags_SRCS})
target_link_libraries(pdwtags dwarves)

set(pglobal_SRCS pglobal.c)
add_executable(pglobal ${pglobal_SRCS})
target_link_libraries(pglobal dwarves)

set(pfunct_SRCS pfunct.c)
add_executable(pfunct ${pfunct_SRCS})
target_link_libraries(pfunct dwarves dwarves_emit ${ELF_LIBRARY})

set(prefcnt_SRCS prefcnt.c)
add_executable(prefcnt ${prefcnt_SRCS})
target_link_libraries(prefcnt dwarves)

set(scncopy_SRCS scncopy.c elfcreator.c)
add_executable(scncopy ${scncopy_SRCS})
target_link_libraries(scncopy dwarves ${ELF_LIBRARY})

set(syscse_SRCS syscse.c)
add_executable(syscse ${syscse_SRCS})
target_link_libraries(syscse dwarves)

install(TARGETS codiff ctracer dtagnames pahole pdwtags
		pfunct pglobal prefcnt scncopy syscse RUNTIME DESTINATION
		${CMAKE_INSTALL_PREFIX}/bin)
install(TARGETS dwarves LIBRARY DESTINATION ${LIB_INSTALL_DIR} ARCHIVE DESTINATION ${LIB_INSTALL_DIR})
install(TARGETS dwarves dwarves_emit dwarves_reorganize LIBRARY DESTINATION ${LIB_INSTALL_DIR} ARCHIVE DESTINATION ${LIB_INSTALL_DIR})
install(FILES dwarves.h dwarves_emit.h dwarves_reorganize.h
	      dutil.h gobuffer.h list.h rbtree.h
	      btf_encoder.h config.h ctf.h
	      elfcreator.h elf_symtab.h hash.h libctf.h
	DESTINATION ${CMAKE_INSTALL_PREFIX}/include/dwarves/)
install(FILES man-pages/pahole.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1/)
install(PROGRAMS ostra/ostra-cg DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
install(PROGRAMS btfdiff fullcircle DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
install(FILES ostra/python/ostra.py DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dwarves/runtime/python)
install(FILES lib/Makefile lib/ctracer_relay.c lib/ctracer_relay.h lib/linux.blacklist.cu
	DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dwarves/runtime)

=== lib/bpf/src/Makefile ===
# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)

ifeq ($(V),1)
	Q =
	msg =
else
	Q = @
	msg = @printf '  %-8s %s%s\n' "$(1)" "$(notdir $(2))" "$(if $(3), $(3))";
endif

LIBBPF_VERSION := $(shell \
	grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | \
	sort -rV | head -n1 | cut -d'_' -f2)
LIBBPF_MAJOR_VERSION := $(firstword $(subst ., ,$(LIBBPF_VERSION)))

TOPDIR = ..

INCLUDES := -I. -I$(TOPDIR)/include -I$(TOPDIR)/include/uapi
ALL_CFLAGS := $(INCLUDES)

SHARED_CFLAGS += -fPIC -fvisibility=hidden -DSHARED

CFLAGS ?= -g -O2 -Werror -Wall
ALL_CFLAGS += $(CFLAGS) -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
ALL_LDFLAGS += $(LDFLAGS)
ifdef NO_PKG_CONFIG
	ALL_LDFLAGS += -lelf -lz
else
	PKG_CONFIG ?= pkg-config
	ALL_CFLAGS += $(shell $(PKG_CONFIG) --cflags libelf zlib)
	ALL_LDFLAGS += $(shell $(PKG_CONFIG) --libs libelf zlib)
endif

OBJDIR ?= .
SHARED_OBJDIR := $(OBJDIR)/sharedobjs
STATIC_OBJDIR := $(OBJDIR)/staticobjs
OBJS := bpf.o btf.o libbpf.o libbpf_errno.o netlink.o \
	nlattr.o str_error.o libbpf_probes.o bpf_prog_linfo.o xsk.o \
	btf_dump.o hashmap.o ringbuf.o
SHARED_OBJS := $(addprefix $(SHARED_OBJDIR)/,$(OBJS))
STATIC_OBJS := $(addprefix $(STATIC_OBJDIR)/,$(OBJS))

STATIC_LIBS := $(OBJDIR)/libbpf.a
ifndef BUILD_STATIC_ONLY
	SHARED_LIBS := $(OBJDIR)/libbpf.so \
		       $(OBJDIR)/libbpf.so.$(LIBBPF_MAJOR_VERSION) \
		       $(OBJDIR)/libbpf.so.$(LIBBPF_VERSION)
	VERSION_SCRIPT := libbpf.map
endif

HEADERS := bpf.h libbpf.h btf.h xsk.h libbpf_util.h \
	   bpf_helpers.h bpf_helper_defs.h bpf_tracing.h \
	   bpf_endian.h bpf_core_read.h libbpf_common.h
UAPI_HEADERS := $(addprefix $(TOPDIR)/include/uapi/linux/,\
			    bpf.h bpf_common.h btf.h)

PC_FILE := $(OBJDIR)/libbpf.pc

INSTALL = install

DESTDIR ?=

ifeq ($(shell uname -m),x86_64)
	LIBSUBDIR := lib64
else
	LIBSUBDIR := lib
endif

# By default let the pc file itself use ${prefix} in includedir/libdir so that
# the prefix can be overridden at runtime (eg: --define-prefix)
ifndef LIBDIR
	LIBDIR_PC := $$\{prefix\}/$(LIBSUBDIR)
else
	LIBDIR_PC := $(LIBDIR)
endif
PREFIX ?= /usr
LIBDIR ?= $(PREFIX)/$(LIBSUBDIR)
INCLUDEDIR ?= $(PREFIX)/include
UAPIDIR ?= $(PREFIX)/include

TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)

all: $(STATIC_LIBS) $(SHARED_LIBS) $(PC_FILE)

$(OBJDIR)/libbpf.a: $(STATIC_OBJS)
	$(call msg,AR,$@)
	$(Q)$(AR) rcs $@ $^

$(OBJDIR)/libbpf.so: $(OBJDIR)/libbpf.so.$(LIBBPF_MAJOR_VERSION)
	$(Q)ln -sf $(^F) $@

$(OBJDIR)/libbpf.so.$(LIBBPF_MAJOR_VERSION): $(OBJDIR)/libbpf.so.$(LIBBPF_VERSION)
	$(Q)ln -sf $(^F) $@

$(OBJDIR)/libbpf.so.$(LIBBPF_VERSION): $(SHARED_OBJS)
	$(call msg,CC,$@)
	$(Q)$(CC) -shared -Wl,--version-script=$(VERSION_SCRIPT) \
		  -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
		  $^ $(ALL_LDFLAGS) -o $@

$(OBJDIR)/libbpf.pc:
	$(Q)sed -e "s|@PREFIX@|$(PREFIX)|" \
		-e "s|@LIBDIR@|$(LIBDIR_PC)|" \
		-e "s|@VERSION@|$(LIBBPF_VERSION)|" \
		< libbpf.pc.template > $@

$(STATIC_OBJDIR) $(SHARED_OBJDIR):
	$(call msg,MKDIR,$@)
	$(Q)mkdir -p $@

$(STATIC_OBJDIR)/%.o: %.c | $(STATIC_OBJDIR)
	$(call msg,CC,$@)
	$(Q)$(CC) $(ALL_CFLAGS) $(CPPFLAGS) -c $< -o $@

$(SHARED_OBJDIR)/%.o: %.c | $(SHARED_OBJDIR)
	$(call msg,CC,$@)
	$(Q)$(CC) $(ALL_CFLAGS) $(SHARED_CFLAGS) $(CPPFLAGS) -c $< -o $@

define do_install
	$(call msg,INSTALL,$1)
	$(Q)if [ ! -d '$(DESTDIR)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR)$2';	\
	fi;
	$(Q)$(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR)$2'
endef

# Preserve symlinks at installation.
define do_s_install
	$(call msg,INSTALL,$1)
	$(Q)if [ ! -d '$(DESTDIR)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR)$2';	\
	fi;
	$(Q)cp -fR $1 '$(DESTDIR)$2'
endef

install: all install_headers install_pkgconfig
	$(call do_s_install,$(STATIC_LIBS) $(SHARED_LIBS),$(LIBDIR))

install_headers:
	$(call do_install,$(HEADERS),$(INCLUDEDIR)/bpf,644)

# UAPI headers can be installed by a different package so they're not installed
# in by install rule.
install_uapi_headers:
	$(call do_install,$(UAPI_HEADERS),$(UAPIDIR)/linux,644)

install_pkgconfig: $(PC_FILE)
	$(call do_install,$(PC_FILE),$(LIBDIR)/pkgconfig,644)

clean:
	$(call msg,CLEAN)
	$(Q)rm -rf *.o *.a *.so *.so.* *.pc $(SHARED_OBJDIR) $(STATIC_OBJDIR)

.PHONY: cscope tags
cscope:
	$(call msg,CSCOPE)
	$(Q)ls *.c *.h > cscope.files
	$(Q)cscope -b -q -f cscope.out

tags:
	$(call msg,CTAGS)
	$(Q)rm -f TAGS tags
	$(Q)ls *.c *.h | xargs $(TAGS_PROG) -a

=== debian/changelog ===
dwarves (1.22-8) unstable; urgency=medium

  * Add binutils-multiarch to the autopkgtest dependencies.

 -- Domenico Andreoli <cavok@debian.org>  Wed, 02 Mar 2022 23:29:15 +0100

dwarves (1.22-7) unstable; urgency=medium

  * Add libdw-dev to the autopkgtest dependencies.

 -- Domenico Andreoli <cavok@debian.org>  Wed, 02 Mar 2022 05:56:50 +0000

dwarves (1.22-6) unstable; urgency=medium

  * Update Standards-Version to 4.6.0.
  * dwarf-struct-with-hole: build and analyze pahole.c
  * Drop kernel build test (closes: #1005014):
    - arch's kernel config package is just a Recommend of the source
      package, as such it's not honoured by autopkgtest. There is no
      way to depend on it without specifying also the kernel version.
  * dwarf-struct-with-hole: exercise the DWARF -> BTF translation.
  * dwarf-struct-with-hole, btf-struct-with-hole:
    print the .BTF section header at the end of the test.

 -- Domenico Andreoli <cavok@debian.org>  Tue, 01 Mar 2022 21:10:29 +0100

dwarves (1.22-5) unstable; urgency=medium

  * Add test: minimal Linux kernel build with BTF.

 -- Domenico Andreoli <cavok@debian.org>  Fri, 04 Feb 2022 18:59:44 +0100

dwarves (1.22-4) unstable; urgency=high

  [Ben Hutchings]
  * Fix inconsistent usage of HAVE_BTF and HAVE_BPF in
    add_cmake_libbpf_enabled_option.patch. Closes: #1004311.

 -- Domenico Andreoli <cavok@debian.org>  Wed, 26 Jan 2022 12:24:40 +0100

dwarves (1.22-3) unstable; urgency=medium

  * debian/rules: fix logic for disabling BPF support on non-linux.
  * Rename test: pahole-struct-with-hole -> dwarf-struct-with-hole.
  * Add test: btf-struct-with-hole.

 -- Domenico Andreoli <cavok@debian.org>  Tue, 25 Jan 2022 21:58:43 +0100

dwarves (1.22-2) unstable; urgency=medium

  * Mark dwarves binary as Multi-Arch foreign.
  * Update libbpf-dev Build-Depends version.
  * Consolidate and forward patches.
  * Add test: pahole-struct-with-hole.
  * Disable BPF support on hurd-i386, kfreebsd-amd64 and kfreebsd-i386:
    - add add_cmake_libbpf_enabled_option.patch
  * Rename branch debian/master to debian/main.

 -- Domenico Andreoli <cavok@debian.org>  Fri, 21 Jan 2022 19:55:31 +0100

dwarves (1.22-1) unstable; urgency=low

  * New upstream release.
    Changes since 1.20:

    pahole:
    - Allow encoding BTF to a separate BTF file (detached) instead of to a new
      ".BTF" ELF section in the file being encoded (vmlinux usually).
    - Introduce -j/--jobs option to specify the number of threads to
      use. Without arguments means one thread per CPU. So far used for
      the DWARF loader, will be used as well for the BTF encoder.
    - Show all different types with the same name, not just the first one found.
    - Introduce sorted type output (--sort), needed with multithreaded
      DWARF loading, to use with things like 'btfdiff' that expects
      the output from DWARF and BTF types to be comparable using 'diff'.
    - Stop assuming that reading from stdin means pretty printing as this broke
      pre-existing scripts, introduce a explicit --prettify command line option.
    - Improve type resolution for the --header command line option.
    - Disable incomplete CTF encoder, this needs to be done using the external
      libctf library.
    - Do not consider the ftrace filter when encoding BTF for kernel functions.
    - Add --kabi_prefix to avoid deduplication woes when using
      _RH_KABI_REPLACE()
    - Add --with_flexible_array to show just types with flexible arrays.

    DWARF Loader:
    - Multithreaded loading, requires elfutils >= 0.178.
    - Lock calls to non-thread safe elfutils' libdw functions (dwarf_decl_file()
      and dwarf_decl_line())
    - Change hash table size to one that performs better with current typical
      vmlinux files.
    - Allow tweaking the hash table size from the command line.
    - Stop allocating memory for strings obtained from libdw, just defer freeing
      the Dwfl handler so that references to its strings can be safely kept.
    - Use a frontend cache for the latest lookup result.
    - Allow ignoring some DWARF tags when loading for encoding
      BTF, as BTF doesn't have equivalents for things like
      DW_TAG_inline_expansion and DW_TAG_label.
    - Allow ignoring some DWARF tag attributes, such as DW_AT_alignment,
      not used when encoding BTF.
    - Do not query for non-C attributes when loading a C language CU
      (compilation unit).

    BTF encoder:
    - Preparatory work for multithreaded encoding, the focus for 1.23.

    btfdiff:
    - Support diffing against a detached BTF file,
      e.g.: 'btfdiff vmlinux vmlinux.btf'
    - Support multithreaded DWARF loading, using the new pahole --sort
      option to have the output from both BTF and DWARF sorted and thus
      comparable via 'diff'.

    Build:
    - Support building with libc libraries lacking either obstacks or argp, such
      as Alpine Linux's musl libc.
    - Support systems without getconf() to obtain the data cacheline size, such
      as musl libc.
    - Add a buildcmd.sh for test builds, tested using the same set of containers
      used for testing the Linux kernel perf tools.
    - Enable selecting building with a shared libdwarves library or statically.
    - Allow one to use the libbpf package found in distributions instead
      of with the accompanying libbpf git submodule.

    Cleanups:
    - Address lots of compiler warnings accumulated by not using -Wextra, it'll
      be added in the next release after allowing not to use it to build libbpf.
    - Address covscan report issues.

    Documentation:
    - Improve the --nr_methods/-m pahole man page entry.
    - Clarify that currently --nr_methods doesn't work together witn -C.

  * Refresh patches.
  * Drop patch no_shared_no_ebl, can do without it.
  * Build-Depends on linux-libc-dev (>= 5.14) for BTF_KIND_FLOAT.
  * Rename source package to dwarves. Closes: #705969.
  * Rename binary package to pahole and add a transitional dummy package.


=== debian/control ===
Source: dwarves
Priority: optional
Maintainer: Thomas Girard <thomas.g.girard@free.fr>
Uploaders: Domenico Andreoli <cavok@debian.org>
Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkg-config, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:0.4~) [linux-any], linux-libc-dev (>= 5.14) [linux-any]
Standards-Version: 4.6.0
Rules-Requires-Root: no
Section: utils
Vcs-Browser: https://salsa.debian.org/debian/dwarves
Vcs-Git: https://salsa.debian.org/debian/dwarves.git
Homepage: https://git.kernel.org/pub/scm/devel/pahole/pahole.git

Package: pahole
Architecture: any
Multi-Arch: foreign
Replaces: dwarves (<< 1.22)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: set of advanced DWARF utilities
 This package contains tools that use the DWARF debugging information
 inserted in ELF binaries by the compiler. This information is used by
 debuggers (e.g. GDB), and other tools such as systemtap.
 .
 Utilities in the dwarves suite include:
 .
  - pahole: finds alignment holes in structs and classes in languages
    such as C/C++, CPU cacheline alignment. Helps repack those structures
    to achieve more cache hits.
  - codiff: a diff like tool to compare the effects changes in source
    code generate on the resulting binaries
  - pfunct: displays all sorts of information about functions, inlines, etc.
  - pdwtags: pretty-prints DWARF information
  - pglobal: lists global symbols
  - prefcnt: counts DWARF tags usage
  - syscse: system call sign extender
  - dtagnames: lists tag names

Package: dwarves
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Depends: pahole (>= 1.22), ${misc:Depends}
Description: set of advanced DWARF utilities - transitional package
 This is a "dummy" package that depends on the newly named pahole.

=== debian/tests/control ===
Tests: btf-struct-with-hole, dwarf-struct-with-hole
Depends: @, gcc, clang, file, libdw-dev, binutils-multiarch

## dwarves 1.23

=== CMakeLists.txt ===
--- 
+++ 
@@ -54,17 +54,18 @@
 endif (NOT DEFINED BUILD_SHARED_LIBS)
 
 # Just for grepping, DWARVES_VERSION isn't used anywhere anymore
-# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.22")
+# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.23")
 add_definitions(-D_GNU_SOURCE -DDWARVES_MAJOR_VERSION=1)
-add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=22)
+add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=23)
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)
 find_package(argp REQUIRED)
 find_package(obstack REQUIRED)
+find_package(Python3 QUIET)
 
 # make sure git submodule(s) are checked out
 find_package(Git QUIET)
-if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
+if(LIBBPF_EMBEDDED AND GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
 	# Update submodules as needed
 	option(GIT_SUBMODULE "Check submodules during build" ON)
 	if(GIT_SUBMODULE)
@@ -185,8 +186,10 @@
 	      elfcreator.h elf_symtab.h hash.h libctf.h
 	DESTINATION ${CMAKE_INSTALL_PREFIX}/include/dwarves/)
 install(FILES man-pages/pahole.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1/)
-install(PROGRAMS ostra/ostra-cg DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
+if(Python3_FOUND)
+	install(PROGRAMS ostra/ostra-cg DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
+	install(FILES ostra/python/ostra.py DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dwarves/runtime/python)
+endif()
 install(PROGRAMS btfdiff fullcircle DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
-install(FILES ostra/python/ostra.py DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dwarves/runtime/python)
 install(FILES lib/Makefile lib/ctracer_relay.c lib/ctracer_relay.h lib/linux.blacklist.cu
 	DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dwarves/runtime)

=== debian/changelog ===
dwarves (1.23-2) unstable; urgency=medium

  * Upload to unstable, linux 5.17 is now available.
  * pahole: add missing Breaks. Closes: #1008093.

 -- Domenico Andreoli <cavok@debian.org>  Wed, 20 Apr 2022 06:52:21 +0200

dwarves (1.23-1) experimental; urgency=medium

  * New upstream release.
    Changes since 1.22:

    DWARF loader:

    - Read DW_TAG_LLVM_annotation tags, associating it with variables,
      functions, types. So far this is only being used by the BTF
      encoder, but the pretty printer should use this as well in a
      future release, printing these attributes when available.

    - Initial support for DW_TAG_skeleton_unit, so far just suggest
      looking up a matching .dwo file to be used instead. Automagically
      doing this is in the plans for a future release.

    - Fix heap overflow when accessing variable specification.

    BTF encoder:

    - Support the new BTF type tag attribute, encoding
      DW_TAG_LLVM_annotation DWARF tags as BTF_KIND_TYPE_TAG and
      BTF_KIND_DECL_TAG.

      This allows __attribute__((btf_type_tag("tag1"))) to be used for
      variables, functions, typedefs, so that contextual information can
      be stored in BTF and used by the kernel BPF verifier for more checks.

      The --skip_encoding_btf_type_tag option can be used to suppress this.

    - Fix handling of percpu symbols on s390.

    BTF loader:

    - Use cacheline size to infer alignment.

    btfdiff:

    - Now that the BTF loader infers struct member alingment, and as that
      is just an heuristic, suppress printing the alignment when pretty
      printing from BTF info like is done when printing from DWARF.

    pahole:

    - Add --skip_missing so that we don't stop when not finding one of
      the types passed to -C.

    Pretty printer:

    - Fix __attribute__((__aligned__(N)) printing alignment for struct
      members.

    - Fix nested __attribute__(__aligned__(N)) struct printing order,
      so that rebuilding from the printed source circles back to the
      original source code alignment semantics.

    Build:

    - No need to download libbpf source when using the system library
      (libbpf-devel).

    - Make python optional

  * Drop pahole-manpage-fixes.patch, merged upstream.
  * Bump build-depends libbpf-dev version to 1:0.7~.
  * Bump build-depends linux-libc-dev version to 5.17~.

 -- Domenico Andreoli <cavok@debian.org>  Tue, 08 Mar 2022 15:39:28 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Thomas Girard <thomas.g.girard@free.fr>
 Uploaders: Domenico Andreoli <cavok@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkg-config, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:0.4~) [linux-any], linux-libc-dev (>= 5.14) [linux-any]
+Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkg-config, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:0.7~) [linux-any], linux-libc-dev (>= 5.17~) [linux-any]
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Section: utils
@@ -14,6 +14,7 @@
 Architecture: any
 Multi-Arch: foreign
 Replaces: dwarves (<< 1.22)
+Breaks: dwarves (<< 1.22)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: set of advanced DWARF utilities
  This package contains tools that use the DWARF debugging information

## dwarves 1.24

=== debian/changelog ===
dwarves (1.24-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * dwarves: Zero-initialize struct cu in cu__new() to prevent incorrect BTF
    types.
    Fixes BTF deduplication issues causing arm64 kernel size increase.
    Thanks to Aurelien Jarno (Closes: #1033301)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 02 May 2023 20:37:16 +0200

dwarves (1.24-4) unstable; urgency=medium

  * Backport upstream patches to support newer toolchains.
    Closes: #1021562.

 -- Domenico Andreoli <cavok@debian.org>  Sat, 10 Dec 2022 10:11:28 +0100

dwarves (1.24-3) unstable; urgency=medium

  * Fix libbpf build-depends-on-1-revision lintian warning.
  * Fix smoketest configuration and dependencies.
  * Fix `upstream-tag` for gbp push.
  * Update standards version to 4.6.1, no changes needed.

 -- Domenico Andreoli <cavok@debian.org>  Tue, 08 Nov 2022 09:39:58 +0100

dwarves (1.24-2) unstable; urgency=medium

  * Upload to unstable.
  * Add libbpf-dev to the autopkgtest dependencies.

 -- Domenico Andreoli <cavok@debian.org>  Mon, 07 Nov 2022 07:48:23 +0100

dwarves (1.24-1) experimental; urgency=medium

  * New upstream release. Closes: 1018906.
    Changes since 1.23:

    BTF encoder:

    - Add support to BTF_KIND_ENUM64 to represent enumeration entries
      with more than 32 bits.

    - Support multithreaded encoding, in addition to DWARF
      multithreaded loading, speeding up the process.

      Selected just like DWARF multithreaded loading, using the
      'pahole -j' option.

    - Encode 'char' type as signed.

    BTF Loader:

    - Add support to BTF_KIND_ENUM64.

    pahole:

    - Introduce --lang and --lang_exclude to specify the language the
      DWARF compile units were originated from to use or filter.

      Use case is to exclude Rust compile units while aspects of the
      DWARF generated for it get sorted out in a way that the kernel
      BPF verifier don't refuse loading the BTF generated from them.

    - Introduce --compile to generate compilable code in a similar
      fashion to

       bpftool btf dump file vmlinux format c > vmlinux.h

      As with 'bpftool', this will notice type shadowing, i.e. multiple
      types with the same name and will disambiguate by adding a suffix.

    - Don't segfault when processing bogus files.

  * Update libbpf-dev and linux-libc-dev build depends.
  * Drop add_cmake_libbpf_enabled_option.patch, not developing it as
    needed for #744847.
  * Run some smoke tests on all the delivered binaries.

 -- Domenico Andreoli <cavok@debian.org>  Sat, 22 Oct 2022 14:31:35 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Priority: optional
 Maintainer: Thomas Girard <thomas.g.girard@free.fr>
 Uploaders: Domenico Andreoli <cavok@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkg-config, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:0.7~) [linux-any], linux-libc-dev (>= 5.17~) [linux-any]
-Standards-Version: 4.6.0
+Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkg-config, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:1.0.1) [linux-any], linux-libc-dev (>= 6.0~) [linux-any]
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Section: utils
 Vcs-Browser: https://salsa.debian.org/debian/dwarves

## dwarves 1.25

=== debian/changelog ===
dwarves (1.25-0ubuntu1~22.04.2) jammy; urgency=medium

  * Backport 1.25 dwarves to stable series (LP: #2025988)
    - Use statically linked vendored libbpf
    - Relax autopkgtest libbpf-dev depends

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Wed, 05 Jul 2023 09:46:31 +0100

dwarves (1.25-0ubuntu1) mantic; urgency=medium

  * New upstream release.
  * Drop cherry-picked patches, included in the new upstream release.
  * Remaining changes:
    - Use vendored, uptodate/compatible uapi headers even when building
    with system libbpf.

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Tue, 25 Apr 2023 14:34:05 +0100

dwarves (1.24-4ubuntu1) lunar; urgency=medium

  * Use vendored, uptodate/compatible uapi headers even when building with
    system libbpf. This allows compiling up to date dwarves without first
    upgrading/migrating new major kernel. Note these are already used when
    doing hwe backports to LTS releases, as vendored libbpf is used as a
    whole together with the vendored uapi headers.

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Tue, 13 Dec 2022 12:35:22 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: dwarves
 Priority: optional
-Maintainer: Thomas Girard <thomas.g.girard@free.fr>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Thomas Girard <thomas.g.girard@free.fr>
 Uploaders: Domenico Andreoli <cavok@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkg-config, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:1.0.1) [linux-any], linux-libc-dev (>= 6.0~) [linux-any]
+Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkg-config, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), linux-libc-dev [linux-any]
 Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Section: utils

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifeq ($(DEB_BUILD_ARCH_OS),linux)
	LIBBPF_OPTS=-DLIBBPF_EMBEDDED=on
else
	LIBBPF_OPTS=-DLIBBPF_ENABLED=off
endif

%:
	dh $@ --builddirectory=debian/build

override_dh_auto_configure:
	dh_auto_configure -- -D__LIB=lib -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE="None" -DBUILD_SHARED_LIBS=off $(LIBBPF_OPTS)

override_dh_auto_install:
	$(MAKE) -C debian/build install DESTDIR=$(CURDIR)/debian/tmp
	# remove them for now, will be included in a next upload
	# (requires python and matplotlib)
	rm -Rf debian/tmp/usr/share/dwarves/runtime/python debian/tmp/usr/bin/ostra-cg
	rm -Rf debian/tmp/usr/lib debian/tmp/usr/include

=== debian/tests/control ===
Tests: btf-struct-with-hole, dwarf-struct-with-hole
Depends: @, gcc, clang, file, binutils-multiarch, libdw-dev, libbpf-dev

Tests: smoketest
Depends: pahole-dbgsym
Restrictions: skip-not-installable, superficial, allow-stderr

## dwarves 1.27

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
+cmake_minimum_required(VERSION 2.8.12)
 project(pahole C)
-cmake_minimum_required(VERSION 2.8.12)
 cmake_policy(SET CMP0005 NEW)
 
 option(LIBBPF_EMBEDDED "Use the embedded version of libbpf instead of searching it via pkg-config" ON)
@@ -54,9 +54,9 @@
 endif (NOT DEFINED BUILD_SHARED_LIBS)
 
 # Just for grepping, DWARVES_VERSION isn't used anywhere anymore
-# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.23")
+# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.27")
 add_definitions(-D_GNU_SOURCE -DDWARVES_MAJOR_VERSION=1)
-add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=23)
+add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=27)
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)
 find_package(argp REQUIRED)
@@ -149,7 +149,7 @@
 
 set(pahole_SRCS pahole.c)
 add_executable(pahole ${pahole_SRCS})
-target_link_libraries(pahole dwarves dwarves_reorganize)
+target_link_libraries(pahole dwarves dwarves_emit dwarves_reorganize)
 
 set(pdwtags_SRCS pdwtags.c)
 add_executable(pdwtags ${pdwtags_SRCS})

=== debian/changelog ===
dwarves (1.27-1ubuntu1) oracular; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Use vendored, uptodate/compatible uapi headers even when building
      with system libbpf.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 12 Jul 2024 20:29:04 +0100

dwarves (1.27-1) unstable; urgency=medium

  * New upstream release.
  * Drop Thomas Girard from the maintainers. Closes: #1065134.
  * Add 00-core-Initialize-cu_node-with-INIT_LIST_HEAD.patch
  * Add 01-dwarf_loader-Add-missing-cus__add-to-cus__merge_and_process_cu.patch
  * Add 02-fix-btf_loader-spelling-error.patch
  * Add 03-reformat-long-line-in-pahole-manpage.patch
  * Clean some files before the build; they are tagged in git but missing
    from MANIFEST and therefore not included in the upstream tarball:
    - PKG-MAINTAINERS
    - README.cross
    - ctfdwdiff
    - tests/reproducible_build.sh

 -- Domenico Andreoli <cavok@debian.org>  Thu, 20 Jun 2024 18:07:31 +0200

dwarves (1.26-1) unstable; urgency=medium

  * New upstream release.
  * Update BD to pkgconf.
  * Update standards version to 4.7.0, no changes needed.
  * Fix copyright year for debian/* files.

  Changes since 1.25:
  [ Arnaldo Carvalho de Melo ]
  * core: Conditionally define language encodings.
  * btf: Fix building with system libbpf.
  * pahole: Honour --compile when -C is used.
  * emit: Check if disambiguated struct/enum/union name was already
    emitted in a previous CU.
  * emit: Don't mark a enum with nr_members == 0 as printed, its just
    a fwd decl.

  [ David Lamparter ]
  * dwarves: support DW_TAG_atomic_type.

  [ Arnaldo Carvalho de Melo ]
  * pahole: Allow --compile to work with DWARF in addition to with BTF.
  * dwarf_loader: Support DW_TAG_label outside DW_TAG_lexblock.
  * pahole: Add "btf" to the format-path option man page.
  * pahole: Support '--lang/--lang_exclude=asm'
  * btf_encoder: Add extra debug info for unsupported DWARF tags.
  * core: Print more info on tag__assert_search_result()
  * fprintf: Emit "_Atomic" modifiers for DW_TAG_atomic_type.
  * btf_encoder: Store the CU being processed to avoid changing many functions.
  * core: Add DW_TAG_unspecified_type to tag__is_tag_type() set.
  * core: Record if a CU has a DW_TAG_unspecified_type.
  * btf_encoder: Encode DW_TAG_unspecified_type returning routines as void.
  * emit: Emit typedefs for atomic_ prefixed base types.
  * emit: Optionally pass a conf_fprintf struct to type_emissions__init.
  * emit: Allow skip emitting the atomic typedefs.
  * pahole: Allow skipping the emission of atomic typedefs.
  * fprintf: Move the "typedef " invariant printf to the start of
    typedef__fprintf()
  * fprintf: Support _Atomic typedefs.
  * emit: Support DW_TAG_atomic_type when emitting definitions for a typedef.

  [ Alan Maguire ]
  * dwarves: Zero-initialize struct cu in cu__new() to prevent incorrect
    BTF types.

  [ Arnaldo Carvalho de Melo ]
  * core: Use zalloc() to make the code more robust.
  * pahole: Use zalloc() to make the code more robust.
  * pfunct: Use zalloc() to make the code more robust.
  * dwarf_loader: DW_TAG_inlined_subroutine needs recoding by
    DW_AT_abstract_origin.
  * core: Introduce base_type__language_defined()
  * pahole: Use type__fprintf() directly for --compile.
  * pahole: Set libbpf debug printer in -V mode.

  [ Sedat Dilek ]
  * dwarf_loader: Sync with LINUX_ELFNOTE_LTO_INFO macro from kernel.

  [ Alan Maguire ]
  * pahole: Sync with libbpf-1.1.
  * dwarf_loader: Help spotting functions with optimized-out parameters.

  [ Arnaldo Carvalho de Melo ]
  * CMakeList.txt: Bump version to the upcoming 1.25 release, not out
    of the door yet.

  [ Alan Maguire ]
  * btf_encoder: Ensure ELF function representation is fully initialized.

  [ Arnaldo Carvalho de Melo ]
  * core: Check that we're adding DW_TAG_member sorted by byte offset.
  * dwarf_loader: Fix sorting of Rust structs.
  * btfdiff: Exclude Rust CUs since those are not yet being converted
    to BTF on the Linux kernel.

  [ Alan Maguire ]
  * dwarf_loader: Mark functions that do not use expected registers for params.
  * btf_encoder: Exclude functions with unexpected param register use
    not optimizations.
  * pahole: Update descriptions for btf_gen_optimized,
    skip_encoding_btf_inconsistent_proto.
  * pahole: Update man page for options also in line with changes made
    to skip logic.
  * dwarf_loader: Fix detection of struct parameters.
  * dwarf_loader: Fix parameter location retrieval for location lists
  * dwarf_loader: Only mark parameter as using an unexpected register
    when it does.

  [ Arnaldo Carvalho de Melo ]
  * CMakeLists.txt: Call cmake_minimum_required() before project()
  * fprintf: Support DW_TAG_LLVM_annotation in dwarf_tag_name()

  [ Eduard Zingerman ]
  * dwarf_loader: Fix for BTF id drift caused by adding unspecified types.

  [ Alan Maguire ]
  * fprintf: Generalize function prototype print to support passing conf
  * fprintf: Support skipping modifier.
  * btf_encoder: Compare functions via prototypes not parameter names.

  [ Eduard Zingerman ]
  * fprintf: Correct names for types with btf_type_tag attribute.
  * btf_loader: A hack for BTF import of btf_type_tag attributes.
  * fprintf: Fix `*` not being printed for pointers with btf_type_tag.

  [ Arnaldo Carvalho de Melo ]
  * pahole: Prep 1.25.
  * dwarf_loader: Add support for DW_TAG_constant.
  * fprintf: Add DW_TAG_constant pretty printer (constant__fprintf)
  * pdwtags: Print DW_TAG_constant tags.
  * dwarf_loader: DW_TAG_subroutine_type may have a DW_AT_byte_size.

  [ Viktor Malik ]
  * spec: Migrate license to a SPDX standardized one.

  [ Arnaldo Carvalho de Melo ]
  * README: Remove old comments about ancient distros and add 'git submodule'
    instruction.
  * pahole: Don't keep structs in multiple RB trees.

  [ Alan Maguire ]
  * btf_encoder, pahole: Move BTF encoding options into 'struct conf_load'
  * dwarves: Move ARRAY_SIZE() to dwarves.h


=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: dwarves
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Thomas Girard <thomas.g.girard@free.fr>
-Uploaders: Domenico Andreoli <cavok@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkg-config, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), linux-libc-dev [linux-any]
-Standards-Version: 4.6.1
+XSBC-Original-Maintainer: Domenico Andreoli <cavok@debian.org>
+Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkgconf, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:1.0.1) [linux-any], linux-libc-dev [linux-any]
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Section: utils
 Vcs-Browser: https://salsa.debian.org/debian/dwarves

## dwarves 1.28

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.5)
 project(pahole C)
 cmake_policy(SET CMP0005 NEW)
 
@@ -21,18 +21,9 @@
 	LINK_DIRECTORIES(${LIBBPF_LIBRARY_DIRS})
 endif()
 
-# Try to parse this later, Helio just showed me a KDE4 example to support
-# x86-64 builds.
-# the following are directories where stuff will be installed to
-set(__LIB "" CACHE STRING "Define suffix of directory name (32/64)" )
-
-macro(_set_fancy _var _value _comment)
-	if (NOT DEFINED ${_var})
-		set(${_var} ${_value})
-	else (NOT DEFINED ${_var})
-		set(${_var} "${${_var}}" CACHE PATH "${_comment}")
-	endif (NOT DEFINED ${_var})
-endmacro(_set_fancy)
+# Use the standard library installation directory
+include(GNUInstallDirs)
+set(CMAKE_INSTALL_LIBDIR "lib" CACHE STRING "libdir name")
 
 # where to look first for cmake modules,
 # before ${CMAKE_ROOT}/Modules/ is checked
@@ -54,9 +45,9 @@
 endif (NOT DEFINED BUILD_SHARED_LIBS)
 
 # Just for grepping, DWARVES_VERSION isn't used anywhere anymore
-# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.27")
+# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.28")
 add_definitions(-D_GNU_SOURCE -DDWARVES_MAJOR_VERSION=1)
-add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=27)
+add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=28)
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)
 find_package(argp REQUIRED)
@@ -84,7 +75,9 @@
 	message(FATAL_ERROR "The submodules were not downloaded! GIT_SUBMODULE was turned off or failed. Please update submodules and try again.")
 endif()
 
-_set_fancy(LIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}${CMAKE_INSTALL_PREFIX}/${__LIB}" "libdir")
+if (NOT DEFINED LIB_INSTALL_DIR)
+    set(LIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
+endif()
 
 # libbpf uses reallocarray, which is not available in all versions of glibc
 # libbpf's include/tools/libc_compat.h provides implementation, but needs

=== debian/changelog ===
dwarves (1.28-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Use vendored, uptodate/compatible uapi headers even when building
      with system libbpf.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 15 Dec 2024 22:20:20 +0000

dwarves (1.28-1) unstable; urgency=medium

  * New upstream release.
  * Drop because merged upstream:
    - 00-core-Initialize-cu_node-with-INIT_LIST_HEAD.patch
    - 01-dwarf_loader-Add-missing-cus__add-to-cus__merge_and_process_cu.patch
  * Add 01-fix-pahole-spelling-error.patch.
  * Clean some files; their permissions are not aligned with git:
    - tests/btf_functions.sh
    - tests/default_vmlinux_btf.sh
    - tests/flexible_arrays.sh
    - tests/prettify_perf.data.sh
    - tests/reproducible_build.sh
    - tests/tests
  * Clean config.h before the build. Closes: #1044846.

 -- Domenico Andreoli <cavok@debian.org>  Tue, 10 Dec 2024 10:36:47 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Domenico Andreoli <cavok@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkgconf, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:1.0.1) [linux-any], linux-libc-dev [linux-any]
+Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), pkgconf, zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:1.0.1) [linux-any], linux-libc-dev (>= 6.0~) [linux-any]
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Section: utils

## dwarves 1.29

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,9 +45,9 @@
 endif (NOT DEFINED BUILD_SHARED_LIBS)
 
 # Just for grepping, DWARVES_VERSION isn't used anywhere anymore
-# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.28")
+# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.29")
 add_definitions(-D_GNU_SOURCE -DDWARVES_MAJOR_VERSION=1)
-add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=28)
+add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=29)
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)
 find_package(argp REQUIRED)

=== debian/changelog ===
dwarves (1.29-3) unstable; urgency=medium

  * Add 03-dwarf_loader-fix-termination-on-BTF-encoding-error.patch.
    Closes: #1100503, #1101262.

 -- Domenico Andreoli <cavok@debian.org>  Fri, 28 Mar 2025 09:39:34 +0100

dwarves (1.29-2) unstable; urgency=medium

  * Build only on Linux, other OSes require major changes.
    Closes: #744847.
  * Forwarded patches upstream.

 -- Domenico Andreoli <cavok@debian.org>  Sat, 01 Feb 2025 14:50:53 +0100

dwarves (1.29-1) unstable; urgency=medium

  * New upstream release.
  * Drop 00-fix-btf_loader-spelling-error.patch, not needed any more.
  * Clean some files; their permissions are not aligned with git:
    - tests/pfunct-btf-decl-tags.sh

 -- Domenico Andreoli <cavok@debian.org>  Tue, 21 Jan 2025 15:47:07 +0100
